#include<glib.h>
#include<SDL/SDL.h>
#include<dlfcn.h>
#include<stdio.h>
#include<gdk/x11/gdkdisplay-x11.h>

void *testlib = NULL;

//For the testworking app, we use these variables instead of the one in the library.
SDL_Surface* DisplaySurface = NULL;
gboolean DisplaySurfaceNeedUpdate = FALSE;

   // Some check are missing from the original function in /gdk/x11/gdkdisplay-x11.c:
void gdk_display_flush(GdkDisplay *display)
   {
   if (!display->closed)
      XFlush (((GdkDisplayX11*)(display))->xdisplay);

   if (DisplaySurfaceNeedUpdate)
      {
      SDL_Flip(DisplaySurface);
      printf("---- Flipping Surface ----\n");
      DisplaySurfaceNeedUpdate = FALSE;
      }
   else
      printf("---- Did not flip surface ----\n");
   }

int main ()
   {
	int *(*fct) () = NULL;

	if (!(testlib = dlopen("./sdlgtklib/sdlgtklib.so", RTLD_NOW)))
	{
		printf("%s\n",dlerror());
		return 1;
	}

	if (!(fct = (int* (*) ())dlsym(testlib, "my_main")))
	{
		printf("%s\n",dlerror());
		return 1;
	}

	(*fct)();
   // gtk does not like to be unloaded.
	//dlclose(testlib);
	return 0;
   }
