#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include <SDL/SDL.h>
#include <stdio.h>
#include <dlfcn.h>
//#include "gtkupdater.h"

// Global variables.
SDL_Surface *DisplaySurface=NULL;
gboolean DisplaySurfaceNeedUpdate=FALSE;

gboolean MapWindowCallback(GtkWidget *widget, GdkEventAny *event, gpointer data)
{
   char variable[64];
   sprintf(variable, "SDL_WINDOWID=0x%lx", GDK_WINDOW_XWINDOW ( GTK_WIDGET(widget)->window ) );
   putenv(variable);

   SDL_Init(SDL_INIT_VIDEO);
   atexit(SDL_Quit);
   DisplaySurface = SDL_SetVideoMode(640, 480, 32, SDL_HWSURFACE | SDL_DOUBLEBUF| SDL_ANYFORMAT);
   SDL_FillRect(DisplaySurface, NULL, 0xFFFFFFFF);
      
   return FALSE;
}

gboolean ExposeSDL (GtkWidget *widget, GdkEventExpose *event, gpointer data)
   {
      SDL_Flip(DisplaySurface);
      DisplaySurfaceNeedUpdate = TRUE;
      return False;
   }

#include <string.h> 
int my_main()
   {
   gtk_init (NULL,NULL);

   GtkWidget *MainWindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   GtkWidget *DrawingAreaForSDL = gtk_drawing_area_new();

   gtk_widget_set_size_request (DrawingAreaForSDL, 640, 480);

   g_signal_connect (G_OBJECT (MainWindow), "delete_event",  G_CALLBACK (gtk_false), NULL);
   g_signal_connect (G_OBJECT (MainWindow), "destroy", G_CALLBACK (gtk_main_quit), NULL);
   g_signal_connect (G_OBJECT (DrawingAreaForSDL), "expose_event", G_CALLBACK (ExposeSDL), NULL);
   g_signal_connect (G_OBJECT (DrawingAreaForSDL), "map_event", G_CALLBACK (MapWindowCallback), NULL);

   gtk_container_add (GTK_CONTAINER (MainWindow), DrawingAreaForSDL);

   gtk_widget_show (MainWindow);
   gtk_widget_show (DrawingAreaForSDL);

   gtk_main ();

   return 0;
   }
